Index: tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/handlers/ComputeAHC.java
===================================================================
--- tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/handlers/ComputeAHC.java	(revision 0)
+++ tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/handlers/ComputeAHC.java	(revision 528)
@@ -0,0 +1,356 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+//
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+//
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+//
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+//
+//
+//
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$
+//
+package org.txm.cah.rcp.handlers;
+
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.jface.dialogs.Dialog;
+import org.eclipse.jface.window.Window;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.Display;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.swt.widgets.Spinner;
+import org.txm.ca.core.functions.CA;
+import org.txm.ca.core.preferences.CAPreferences;
+import org.txm.cah.core.functions.AHC;
+import org.txm.cah.core.messages.AHCCoreMessages;
+import org.txm.cah.core.preferences.AHCPreferences;
+import org.txm.cah.rcp.messages.AHCUIMessages;
+import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
+import org.txm.chartsengine.rcp.editors.ChartEditorInput;
+import org.txm.chartsengine.rcp.editors.ChartEditorPart;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.TXMParameters;
+import org.txm.lexicaltable.core.functions.LexicalTable;
+import org.txm.lexicaltable.core.functions.LexicalTableFactory;
+import org.txm.lexicaltable.rcp.editors.LexicalTableDialog;
+import org.txm.rcp.handlers.BaseAbstractHandler;
+import org.txm.rcp.views.corpora.CorporaView;
+import org.txm.searchengine.cqp.corpus.Partition;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.statsengine.core.StatException;
+import org.txm.utils.logger.Log;
+
+/**
+ * If the selection is a CA or a Lexical Table result computes the CAH.
+ *
+ * @author mdecorde
+ * @author sjacquot
+ */
+public class ComputeAHC extends BaseAbstractHandler {
+
+
+	// adds a double click listener to the Corpus View
+	static	{
+		CorporaView.addDoubleClickListener(AHC.class, ComputeAHC.class);
+	}
+	
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+
+
+		if(!this.checkStatsEngine()) {
+			return null;
+		}
+
+		Object selection = this.getSelection();
+		ChartEditorInput editorInput = null;
+		
+		
+		
+		CA ca = null;
+
+		
+		// reopening an existing result
+		if (selection instanceof AHC) {
+			editorInput = new ChartEditorInput((AHC) selection);
+		}
+		// creates from CA
+		else if (selection instanceof CA) {
+			ca = (CA) selection;
+		}
+		// creates from LexicalTable
+		else if (selection instanceof LexicalTable) {
+			//System.out.println("Compute CAH with LT : "+((LexicalTable)selection.getFirstElement()).getName());
+			LexicalTable lexicaltable = (LexicalTable) selection;
+			
+			try {
+				ca = new CA(lexicaltable);
+			} catch (StatException e) {
+				System.out.println("Failed to build the CA with lexical table " + lexicaltable + ": " + e);
+				Log.printStackTrace(e);
+			}
+			lexicaltable.addResult(ca);
+			
+//			if (lexicaltable.getPartition() != null)
+//				lexicaltable.getPartition().storeResult(ca);
+//			else if (lexicaltable.getCorpus() != null)
+//				lexicaltable.getCorpus().storeResult(ca);
+		}
+		// creates from Partition
+		else if (selection instanceof Partition) {
+			//System.out.println("Compute CAH with Partition : "+((Partition)selection.getFirstElement()).getName());
+			Partition partition = (Partition)selection;
+			try {
+				String title = AHCUIMessages.bind(AHCUIMessages.ComputeCAH_0, partition.getName());
+				int vmax = TXMPreferences.getInt(CAPreferences.V_MAX, CAPreferences.PREFERENCES_NODE);
+				int fmin = TXMPreferences.getInt(CAPreferences.F_MIN, CAPreferences.PREFERENCES_NODE);
+				Shell shell = Display.getCurrent().getActiveShell();
+				LexicalTableDialog d = new LexicalTableDialog(shell, partition.getCorpus(), title);
+				d.setFminAndVMax(fmin, vmax);
+				
+				if (d.open() == Window.OK) {
+					Property property = d.getProperty();
+					fmin = d.getFmin();
+					vmax = d.getMaxLines();
+					
+					LexicalTable lexicaltable = LexicalTableFactory.getLexicalTable(partition, property, fmin); // use the CAPreferencePage Fmin
+					lexicaltable.getData().cut(vmax);
+					partition.addResult(lexicaltable);
+					
+					ca = new CA(lexicaltable);
+					lexicaltable.addResult(ca);
+				} else {
+					// canceled
+					return null;
+				}
+			} catch (Exception e) {
+				System.out.println("Failed to build the lexical table of " + partition + ": " + e);
+				Log.printStackTrace(e);
+				return null;
+			} 
+		}
+
+		if (ca != null)	{
+			AHC cah = new AHC(ca);
+			
+			TXMParameters parameters = new TXMParameters();
+			parameters.put(AHCPreferences.COLUMNS_COMPUTING, TXMPreferences.getBoolean(AHCPreferences.COLUMNS_COMPUTING, AHCPreferences.PREFERENCES_NODE));
+			parameters.put(AHCPreferences.METHOD, TXMPreferences.getString(AHCPreferences.METHOD, AHCPreferences.PREFERENCES_NODE));
+			parameters.put(AHCPreferences.METRIC, TXMPreferences.getString(AHCPreferences.METRIC, AHCPreferences.PREFERENCES_NODE));
+			parameters.put(AHCPreferences.N_CLUSTERS, TXMPreferences.getInt(AHCPreferences.N_CLUSTERS, AHCPreferences.PREFERENCES_NODE));
+			cah.setParameters(parameters);
+			
+			editorInput = new ChartEditorInput(cah);
+		}
+		
+		ChartEditorPart editor = SWTChartsComponentsProvider.getCurrent().openEditor(editorInput);
+
+		// computes if not reopening a result
+		if(!(selection instanceof AHC))	{
+			editor.computeResult();
+		}
+		
+
+		return null;
+	}
+
+
+
+
+	/**
+	 * The Class CAHParamDialog.
+	 */
+	// FIXME: not used?
+	public class CAHParamDialog extends Dialog {
+
+		//protected Combo methodsCombo;
+		//protected Combo metricsCombo;
+		/** The ncluster spinner. */
+		protected Spinner nclusterSpinner;
+
+		/** The docolumns button. */
+		protected Button docolumnsButton;
+
+		/** The title. */
+		protected String title;
+
+		/**
+		 * Instantiates a new cAH param dialog.
+		 *
+		 * @param parentShell the parent shell
+		 */
+		public CAHParamDialog(Shell parentShell) {
+			super(parentShell);
+			this.title = AHCCoreMessages.RESULT_TYPE;
+		}
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.window.Window#configureShell(org.eclipse.swt.widgets.Shell)
+		 */
+		@Override
+		protected void configureShell(Shell newShell) {
+			super.configureShell(newShell);
+
+			if (title != null)
+				newShell.setText(title);
+			else
+				newShell.setText(AHCCoreMessages.RESULT_TYPE);
+		}
+
+		/** The composite. */
+		protected Composite composite;
+
+		/** The method. */
+		private String method;
+
+		/** The metric. */
+		private String metric;
+
+		/** The Ncluster. */
+		private int Ncluster;
+
+		/** The doculumns. */
+		private boolean doculumns;
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
+		 */
+		@Override
+		protected Control createDialogArea(Composite parent) {
+			composite = new Composite(parent, SWT.NONE);
+			GridLayout layout = new GridLayout(2, false);
+			composite.setLayout(layout);
+
+			// N CLUSTERS
+			Label label = new Label(composite, SWT.NONE);
+			label.setText(AHCUIMessages.CAHPreferencePage_2);
+
+			nclusterSpinner = new Spinner(composite, SWT.BORDER);
+			nclusterSpinner.setMinimum(2);
+			nclusterSpinner.setIncrement(1);
+			nclusterSpinner.setSelection(TXMPreferences.getInt(AHCPreferences.N_CLUSTERS, AHCPreferences.PREFERENCES_NODE));
+			nclusterSpinner.setMaximum(50);
+
+			// ROWS OR COLS
+			docolumnsButton = new Button(composite, SWT.RADIO);
+			docolumnsButton.setText(AHCUIMessages.COMPUTE_COLUMNS);
+			docolumnsButton.setSelection(true);
+
+			Button dorowsButton = new Button(composite, SWT.RADIO);
+			dorowsButton.setText(AHCUIMessages.COMPUTE_ROWS);
+
+			/*
+			// METHODS
+			Label methodLabel = new Label(composite, SWT.NONE);
+			methodLabel.setText("Methods");
+
+			methodLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+
+			methodsCombo = new Combo(composite, SWT.READ_ONLY);
+			methodsCombo.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
+					true, false));
+			methodsCombo.select(methodsCombo.indexOf(CAH.getDefaultMethod()));
+			for(String method : CAH.getMethods())
+				methodsCombo.add(method);
+
+			// METRICS
+			Label metricsLabel = new Label(composite, SWT.NONE);
+			metricsLabel.setText("Methods");
+
+			metricsLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+
+			metricsCombo = new Combo(composite, SWT.READ_ONLY);
+			metricsCombo.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
+					true, false));
+			metricsCombo.select(metricsCombo.indexOf(CAH.getDefaultMetric()));
+			for(String method : CAH.getMetrics())
+				metricsCombo.add(method);
+				*/
+
+			return composite;
+		}
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
+		 */
+		@Override
+		protected void okPressed() {
+			/*int idx = methodsCombo.getSelectionIndex();
+			method = methodsCombo.getItem(idx);
+
+			idx = metricsCombo.getSelectionIndex();
+			metric = metricsCombo.getItem(idx);
+*/
+			Ncluster = this.nclusterSpinner.getSelection();
+
+			doculumns = this.docolumnsButton.getSelection();
+
+			super.okPressed();
+		}
+
+		/**
+		 * Gets the method.
+		 *
+		 * @return the method
+		 */
+		public String getMethod() {
+			return method;
+		}
+
+		/**
+		 * Gets the metric.
+		 *
+		 * @return the metric
+		 */
+		public String getMetric() {
+			return metric;
+		}
+
+		/**
+		 * Gets the ncluster.
+		 *
+		 * @return the ncluster
+		 */
+		public int getNcluster() {
+			return Ncluster;
+		}
+
+		/**
+		 * Checks if is doculumns.
+		 *
+		 * @return true, if is doculumns
+		 */
+		public boolean isDoculumns() {
+			return doculumns;
+		}
+	}
+
+
+}

Index: tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/preferences/AHCPreferencePage.java
===================================================================
--- tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/preferences/AHCPreferencePage.java	(revision 0)
+++ tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/preferences/AHCPreferencePage.java	(revision 528)
@@ -0,0 +1,97 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.cah.rcp.preferences;
+
+import org.eclipse.jface.preference.ComboFieldEditor;
+import org.eclipse.jface.preference.IntegerFieldEditor;
+import org.eclipse.jface.preference.RadioGroupFieldEditor;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.ui.IWorkbench;
+import org.txm.cah.core.functions.AHC;
+import org.txm.cah.core.messages.AHCCoreMessages;
+import org.txm.cah.core.preferences.AHCPreferences;
+import org.txm.cah.rcp.adapters.AHCAdapterFactory;
+import org.txm.cah.rcp.messages.AHCUIMessages;
+import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
+import org.txm.rcp.preferences.TXMPreferencePage;
+import org.txm.rcp.preferences.TXMPreferenceStore;
+
+/**
+ * CAH preferences page.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ */
+public class AHCPreferencePage extends TXMPreferencePage {
+
+
+
+	@Override
+	public void createFieldEditors() {
+
+		IntegerFieldEditor nClusters = new IntegerFieldEditor(AHCPreferences.N_CLUSTERS, AHCUIMessages.CAHPreferencePage_2, getFieldEditorParent());
+		addField(nClusters);
+
+		String list[] = AHC.getMethods(); 
+		String methods[][] = new String[list.length][2];
+		for(int i = 0 ; i < list.length ; i++)
+			methods[i][0] = methods[i][1] = list[i];
+				
+		ComboFieldEditor method = new ComboFieldEditor(AHCPreferences.METHOD, AHCUIMessages.CAHPreferencePage_3, methods, getFieldEditorParent());
+		addField(method);
+
+		list = AHC.getMetrics(); 
+		String metrics[][] = new String[list.length][2];
+		for(int i = 0 ; i < list.length ; i++)
+			metrics[i][0] = metrics[i][1] = list[i];
+		
+		ComboFieldEditor metric = new ComboFieldEditor(AHCPreferences.METRIC, AHCUIMessages.CAHPreferencePage_4, metrics, getFieldEditorParent());
+		addField(metric);
+		
+		
+		// Charts
+		Composite chartsTab = SWTChartsComponentsProvider.createChartsRenderingPreferencesTabFolderComposite(getFieldEditorParent());
+
+		String[][] labelAndValues = {{"2D", "true"}, {"3D", "false"}}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
+		RadioGroupFieldEditor default2D3Ddisplay = new RadioGroupFieldEditor(AHCPreferences.DISPLAY_2D, AHCUIMessages.CAHPreferencePage_0, 2, labelAndValues, chartsTab);
+		addField(default2D3Ddisplay);
+		
+		
+		// other shared preferences
+		SWTChartsComponentsProvider.createChartsRenderingPreferencesFields(this, chartsTab);
+	}
+
+	@Override
+	public void init(IWorkbench workbench) {
+		this.setPreferenceStore(new TXMPreferenceStore(AHCPreferences.PREFERENCES_NODE));
+		//setDescription("AHC");
+		this.setTitle(AHCCoreMessages.RESULT_TYPE);
+		this.setImageDescriptor(AHCAdapterFactory.ICON);
+	}
+
+}

Index: tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/adapters/AHCAdapterFactory.java
===================================================================
--- tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/adapters/AHCAdapterFactory.java	(revision 0)
+++ tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/adapters/AHCAdapterFactory.java	(revision 528)
@@ -0,0 +1,47 @@
+// Copyright © 2010-2013 ENS de Lyon.
+package org.txm.cah.rcp.adapters;
+
+import org.eclipse.jface.resource.ImageDescriptor;
+import org.eclipse.ui.model.IWorkbenchAdapter;
+import org.eclipse.ui.plugin.AbstractUIPlugin;
+import org.osgi.framework.FrameworkUtil;
+import org.txm.cah.core.functions.AHC;
+import org.txm.rcp.adapters.TXMResultAdapter;
+import org.txm.rcp.adapters.TXMResultAdapterFactory;
+
+/**
+ * A factory for creating Adapter objects.
+ *  
+ * @author mdecorde
+ * @author sjacquot
+ */
+public class AHCAdapterFactory extends TXMResultAdapterFactory {
+
+	
+	public static final ImageDescriptor ICON =
+			AbstractUIPlugin.imageDescriptorFromPlugin(FrameworkUtil.getBundle(AHCAdapterFactory.class).getSymbolicName(),
+					"platform:/plugin/"+ FrameworkUtil.getBundle(AHCAdapterFactory.class).getSymbolicName() + "/icons/cah.png"); //$NON-NLS-1$
+	
+	/**
+	 * Gets the adapter.
+	 *
+	 * @param adaptableObject the adaptable object
+	 * @param adapterType the adapter type
+	 * @return the adapter
+	 * @see org.eclipse.core.runtime.IAdapterFactory#getAdapter(java.lang.Object, java.lang.Class)
+	 */
+	@Override
+	public Object getAdapter(Object adaptableObject, Class adapterType) {
+		if(adapterType == IWorkbenchAdapter.class && adaptableObject instanceof AHC)	{
+			return new TXMResultAdapter() {
+				@Override
+				public ImageDescriptor getImageDescriptor(Object object) {
+					return ICON;
+				}
+			};
+		}
+		return null;
+	}
+
+
+}

Index: tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/messages/AHCUIMessages.java
===================================================================
--- tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/messages/AHCUIMessages.java	(revision 0)
+++ tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/messages/AHCUIMessages.java	(revision 528)
@@ -0,0 +1,39 @@
+package org.txm.cah.rcp.messages;
+
+import org.eclipse.osgi.util.NLS;
+import org.txm.utils.messages.Utf8NLS;
+
+public class AHCUIMessages extends NLS {
+
+	private static final String BUNDLE_NAME = "org.txm.cah.rcp.messages.messages"; //$NON-NLS-1$
+	
+	
+	public static String CAHPreferencePage_0;
+	public static String CAHPreferencePage_2;
+	public static String CAHPreferencePage_3;
+	public static String CAHPreferencePage_4;
+	
+	public static String ComputeCAH_0;
+	
+	//FIXME: these keys/values are not used, remove or use them?
+	public static String ComputeCAH_1;
+	public static String ComputeCAH_2;
+	public static String ComputeCAH_3;
+	public static String ComputeCAH_5;
+	public static String ComputeCAH_6;
+	// end of fixme
+	
+	public static String COMPUTE_COLUMNS;
+	public static String COMPUTE_ROWS;
+	
+	public static String CHART_TOOLBAR_BUTTON_NUMBER_OF_CLUSTERS;
+	
+	static {
+		// initializes resource bundle
+		Utf8NLS.initializeMessages(BUNDLE_NAME, AHCUIMessages.class);
+	}
+	
+	private AHCUIMessages() {
+		//no instantiation
+	}
+}

Index: tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/editors/AHCChartEditor.java
===================================================================
--- tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/editors/AHCChartEditor.java	(revision 0)
+++ tmp/org.txm.cah.rcp/src/org/txm/cah/rcp/editors/AHCChartEditor.java	(revision 528)
@@ -0,0 +1,242 @@
+package org.txm.cah.rcp.editors;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.custom.CLabel;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.graphics.Image;
+import org.eclipse.swt.widgets.Combo;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Spinner;
+import org.eclipse.swt.widgets.ToolItem;
+import org.txm.cah.core.functions.AHC;
+import org.txm.cah.core.messages.AHCCoreMessages;
+import org.txm.cah.core.preferences.AHCPreferences;
+import org.txm.cah.rcp.messages.AHCUIMessages;
+import org.txm.chartsengine.rcp.editors.ChartEditorPart;
+import org.txm.chartsengine.rcp.messages.SWTComponentsProviderMessages;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.TXMResult;
+import org.txm.rcp.IImageKeys;
+import org.txm.rcp.JobsTimer;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.rcp.views.QueriesView;
+import org.txm.statsengine.r.rcp.views.RVariablesView;
+import org.txm.utils.logger.Log;
+
+/**
+ * CAH chart editor.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ *
+ */
+public class AHCChartEditor extends ChartEditorPart {
+
+	/**
+	 * Numbers of clusters.
+	 */
+	protected Spinner numbersOfClusters;
+
+
+
+	@Override
+	public void createPartControl(Composite parent) {
+
+		super.createPartControl(parent);
+
+		// Extend the chart editor tool bar
+		ToolItem separator = new ToolItem(this.topToolBar, SWT.SEPARATOR);
+
+		// Number of clusters
+		ToolItem itemSeparator = new ToolItem(this.topToolBar, SWT.SEPARATOR);
+	    CLabel clustersLabel = new CLabel(this.topToolBar, SWT.CENTER);
+		clustersLabel.setText(AHCUIMessages.CHART_TOOLBAR_BUTTON_NUMBER_OF_CLUSTERS);
+		clustersLabel.pack();
+		itemSeparator.setWidth(clustersLabel.getBounds().width);
+	    itemSeparator.setControl(clustersLabel);
+
+	    itemSeparator = new ToolItem(this.topToolBar, SWT.SEPARATOR);
+	    this.numbersOfClusters = new Spinner(this.topToolBar, SWT.BORDER);
+	    this.numbersOfClusters.setMinimum(2);
+	    this.numbersOfClusters.setIncrement(1);
+
+		itemSeparator.setControl(this.numbersOfClusters);
+		this.numbersOfClusters.pack();
+		itemSeparator.setWidth(this.numbersOfClusters.getBounds().width);
+
+
+		// Columns
+		final ToolItem computeColumns = new ToolItem(this.topToolBar, SWT.RADIO);
+		computeColumns.setToolTipText(AHCUIMessages.COMPUTE_COLUMNS);
+		computeColumns.setImage(IImageKeys.getImage(AHCChartEditor.class, "icons/compute_columns.png")); //$NON-NLS-1$
+		// FIXME: keep this for offering an option "large icons" with text in buttons ?
+		//computeColumns.setText(CAUIPMessages.ComputeClassification_5);
+		computeColumns.setSelection(this.getBooleanParameterValue(AHCPreferences.COLUMNS_COMPUTING));
+
+		// Rows
+		final ToolItem computeRows = new ToolItem(this.topToolBar, SWT.RADIO);
+		computeRows.setToolTipText(AHCUIMessages.COMPUTE_ROWS);
+		computeRows.setImage(IImageKeys.getImage(AHCChartEditor.class, "icons/compute_rows.png")); //$NON-NLS-1$
+		// FIXME: keep this for offering an option "large icons" with text in buttons ?
+		//computeRows.setText(CAUIPMessages.ComputeClassification_6);
+		computeRows.setSelection(!this.getBooleanParameterValue(AHCPreferences.COLUMNS_COMPUTING));
+
+		
+		// 2D/3D
+		final Combo displayCombo = new Combo(this.topToolBar, SWT.READ_ONLY);
+		String items[] = { "2D", "3D" }; //$NON-NLS-1$ //$NON-NLS-2$
+		displayCombo.setItems(items);
+		if(this.getBooleanParameterValue(AHCPreferences.DISPLAY_2D))	{
+			displayCombo.select(0);
+		}
+		else	{
+			displayCombo.select(1);
+		}
+		
+		ToolItem comboItem = new ToolItem(this.topToolBar, SWT.SEPARATOR);
+		comboItem.setControl(displayCombo);
+		displayCombo.pack();
+		comboItem.setWidth(displayCombo.getBounds().width);
+		
+		// Listeners
+		SelectionListener listener = new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				AHC cah = getResultData();
+
+				// Numbers of clusters
+				if(e.getSource() == numbersOfClusters)	{
+					
+					cah.setNCluster(((Spinner)e.getSource()).getSelection());
+				}
+				// Compute columns or rows
+				else if(e.getSource() == computeColumns || e.getSource() == computeRows)	{
+					
+					// cancel the event if nothing has changed
+//					if(e.getSource() == computeColumns && computeColumns.getSelection()
+//							|| e.getSource() == computeRows && computeRows.getSelection())	{
+//						return;
+//					}
+					
+					cah.setColumnsComputing(computeColumns.getSelection());
+					
+					// reset the number of clusters
+					cah.setNCluster(TXMPreferences.getInt(AHCPreferences.N_CLUSTERS, AHCPreferences.PREFERENCES_NODE));
+
+					updateNumbersOfClustersCurrentValue();
+					// Update the maximum value of the number of clusters spinner according to the new CAH configuration 
+					updateNumbersOfClustersMaxValue();
+				}
+				else if(e.getSource() == displayCombo)	{
+					TXMPreferences.putLocalBoolean(cah, AHCPreferences.DISPLAY_2D, (displayCombo.getSelectionIndex() == 0));
+				}
+				
+				
+				// Recompute the CAH and the chart
+				computeResult(true);
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				// TODO Auto-generated method stub
+				
+			}
+		};
+		
+		this.numbersOfClusters.addSelectionListener(listener);
+		computeColumns.addSelectionListener(listener);
+		displayCombo.addSelectionListener(listener);
+		
+		this.computeResult(false);
+		
+		
+
+	}
+
+
+	/**
+	 * Computes the result and the chart.
+	 * @param update
+	 */
+	public void computeResult(final boolean update)	{
+		
+		JobHandler jobhandler = new JobHandler(AHCCoreMessages.LOG_COMPUTE_CAH) {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				try {
+
+					this.acquireSemaphore();
+					getResultData().compute(false, this);
+					this.releaseSemaphore();
+
+					if(!update)	{
+
+						getResultData().getCA().addResult(getResultData());
+						
+						// Refresh views
+						this.syncExec(new Runnable() {
+							@Override
+							public void run() {
+								
+							    updateNumbersOfClustersMaxValue();
+							    updateNumbersOfClustersCurrentValue();
+
+								QueriesView.refresh();
+								RVariablesView.refresh();
+							}
+						});
+					
+						
+					}
+					
+					computeChart(update);
+					
+				}
+				// for user direct canceling
+				catch (ThreadDeath td) {
+					return Status.CANCEL_STATUS;
+				}
+				catch (Exception e) {
+					System.out.println(e.getLocalizedMessage());
+					org.txm.rcp.utils.Logger.printStackTrace(e);
+					Log.severe("Error while computing CAH: " + e.getLocalizedMessage());
+				}
+				finally {
+					monitor.done();
+					JobsTimer.stopAndPrint();
+				}
+				return Status.OK_STATUS;
+			}
+		};
+		jobhandler.startJob();
+	}
+	
+	
+	
+	
+	/**
+	 * Updates the maximum value of the number of clusters spinner according to the CAH configuration.
+	 */
+	public void updateNumbersOfClustersMaxValue()	{
+		int max = this.getResultData().getMaxClustersCount();
+		this.numbersOfClusters.setMaximum(max);
+	}
+
+	/**
+	 * Updates the current value of the number of clusters spinner.
+	 */
+	public void updateNumbersOfClustersCurrentValue()	{
+		this.numbersOfClusters.setSelection(TXMPreferences.getInt(AHCPreferences.PREFERENCES_NODE, this.getResultData(), AHCPreferences.N_CLUSTERS));
+	}
+
+	@Override
+	public AHC getResultData() {
+		return (AHC) super.getResultData();
+	}
+}

Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditorPart.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditorPart.java	(revision 527)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditorPart.java	(revision 528)
@@ -64,6 +64,12 @@
 
 	private Composite topToolBarContainer;
 	
+	/**
+	 * State value to create or not the computing parameters area and tool bar button.
+	 */
+	protected boolean createComputingParametersArea = true;
+	
+	
 	@Override
 	public void init(IEditorSite site, IEditorInput input) throws PartInitException {
 		this.setSite(site);
@@ -75,42 +81,60 @@
 	}
 	
 	/**
-	 * Creates the default toolbar (empty) and default result area (empty)
+	 * Creates the default toolbar (empty) and default result area (empty).
 	 * 
 	 */
 	@Override
 	public void createPartControl(Composite parent) {
 		
-		this.parent = parent;
-		
-		// to hide and display the command parameters composite
-		this.initParentLayout(parent, 1);
+		try {
+			this.parent = parent;
+			
+			// to hide and display the command parameters composite
+			this.initParentLayout(parent, 1);
 
-		// create the top tool bar
-		topToolBarContainer = new Composite(parent, SWT.NONE);
-		topToolBarContainer.setLayoutData(new GridData(GridData.FILL,GridData.FILL,true, false));
-		
-		RowLayout rl = new RowLayout(SWT.HORIZONTAL);
-		rl.marginTop = rl.marginHeight = rl.marginWidth = rl.marginBottom = 0;
-		topToolBarContainer.setLayout(rl);
-		
-		this.topToolBar = new TXMEditorToolBar(topToolBarContainer, SWT.FLAT | SWT.RIGHT, "top", this);
-		
-		parametersGroupsComposite = new Composite(parent, SWT.NONE);
-		GridLayout gl = new GridLayout(1, true);
-		gl.marginBottom = gl.marginHeight = gl.marginWidth = gl.marginTop = 0;
-		parametersGroupsComposite.setLayout(gl);
-		if (parent.getLayout() instanceof GridLayout)
-		parametersGroupsComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
-		
-		computingParametersGroup = topToolBar.installGroup("Computing parameters", "Show/Hide command parameters", "icons/show_computing_parameters.png");
-		topToolBar.setVisible(computingParametersGroup, true);
-		
-		displayArea = new Composite(parent, SWT.NONE);
-		displayArea.setLayoutData(new GridData(GridData.FILL_BOTH));
-		
-		// bottom tool bar
-		this.bottomToolBar = new TXMEditorToolBar(parent, SWT.FLAT, "bottom", this);
+			// create the top tool bar
+			this.topToolBarContainer = new Composite(parent, SWT.NONE);
+			this.topToolBarContainer.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
+			
+			RowLayout rl = new RowLayout(SWT.HORIZONTAL);
+			rl.marginTop = rl.marginHeight = rl.marginWidth = rl.marginBottom = 0;
+			this.topToolBarContainer.setLayout(rl);
+			
+			this.topToolBar = new TXMEditorToolBar(this.topToolBarContainer, SWT.FLAT | SWT.RIGHT, "top", this);
+			
+			
+			this.parametersGroupsComposite = new Composite(parent, SWT.NONE);
+			GridLayout gl = new GridLayout(1, true);
+			gl.marginBottom = gl.marginHeight = gl.marginWidth = gl.marginTop = 0;
+			this.parametersGroupsComposite.setLayout(gl);
+			if (parent.getLayout() instanceof GridLayout)	{
+				this.parametersGroupsComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
+			}
+
+			// computing parameters components
+			if(this.createComputingParametersArea)	{
+				// only show the area if the result can not compute and is dirty
+				boolean showComputingParameters = false; 
+				if(this.getResultData().isDirty() && !this.getResultData().canCompute())	{
+					showComputingParameters = true;
+				}
+				this.computingParametersGroup = topToolBar.installGroup("Computing parameters", "Show/Hide command parameters", "icons/show_computing_parameters.png", showComputingParameters);
+			}
+			
+
+			// display main area
+			this.displayArea = new Composite(parent, SWT.NONE);
+			this.displayArea.setLayoutData(new GridData(GridData.FILL_BOTH));
+			
+			
+			// bottom tool bar
+			this.bottomToolBar = new TXMEditorToolBar(parent, SWT.FLAT, "bottom", this);
+		}
+		catch(Exception e) {
+			System.err.println("TXMEditorPart.createPartControl(): can not create the editor.");
+			e.printStackTrace();
+		}
 	}
 	
 	public Composite getTopToolBarContainer() {
@@ -280,7 +304,7 @@
 
 						result.setParameters(parameters);
 
-						if (result.validateParameters() && result.isDirty()) {
+						if (result.canCompute() && result.isDirty()) {
 
 							String title = "";//result.getComputingMessage();
 							System.out.println(title);
@@ -357,7 +381,7 @@
 				this.setPartName(this.getResultData().getName());
 			}
 		} catch(Exception e) {
-			System.out.println("Error while refreshing editor content: "+e.getLocalizedMessage());
+			System.out.println("Error while refreshing editor content: " + e.getLocalizedMessage());
 		}
 	}
 	
@@ -369,7 +393,7 @@
 		try {
 			return this.getEditorInput().deleteResult();
 		} catch(Exception e) {
-			System.out.println("Error: could not delete result: "+e.getLocalizedMessage());
+			System.out.println("Error: could not delete result: " + e.getLocalizedMessage());
 			return false;
 		}
 	}
